//Script Name:
//////////////////////////////////////////
// Created By: Genisys (Guile)
// Created On: 8/13/08
//
// (TABASED ITEM SCRIPT TEMPLATE)
/////////////////////////////////////////
/*
This template is used for ALL events which
happen for an item which has the same
tagname as the name of this script.
(You need to name this script the item's tagname)

Every event below will fire when the event
happens, ie. If the player activates the item
the X2_ITEM_EVENT_ACTIVATE: script code will run.

*/
////////////////////////////////////////

#include "x2_inc_switches"
#include "prc_class_const"

//Main Script
void main()
{

    //All Major Variables Declared (Commonly used variables as well)

    int nEvent = GetUserDefinedItemEventNumber();  //Which event triggered this
    object oPC;                                   //The player character using the item
    object oItem;                                //The item being used
    object oSpellOrigin;                        //The origin of the spell
    object oSpellTarget;                       //The target of the spell
    int iSpell;                               //The Spell ID number
    object oTarget;     //Define oTarget below
    object oObject;     //Define oObject below
    int nInt;           //A commonly used intergal (Must be defined)
    int nLvl;           //Commonly used intergal for levels  (ie. GetHitDice(oTarget); etc.)
    string sTag;        //Used to define a tagname of something
    string sResref;     //Used to define a resref name of something
    string sMsg;        //Used to define a message
    effect eEffect;     //Used to define an effect to be applied to an object or location
    effect eVis;        //Used to define a visual effect to be applied to an object or location
    location lTarget;   //The Target Location of the PC ONLY! (USE - Getlocation(oPC);)
    location lway;      //The Target location for the Activated Item's Target only! (See below)

    int nWLvl;
    int nSLvl;
    int nCLvl;
    int nRDC;
    int nCDmg;
    int nDDmg;


////////////////////////////////////////////////////////////////////////////////////////////////
  //Set the return value for the item event script
  // * X2_EXECUTE_SCRIPT_CONTINUE - continue calling script after executed script is done
  // * X2_EXECUTE_SCRIPT_END - end calling script after executed script is done
  int nResult = X2_EXECUTE_SCRIPT_END;
///////////////////////////////////////////////////////////////////////////////////////////////

    //Deterimine which event has fired for the item...
    switch (nEvent)
    {

////////////////////////////////////////////////////////////////////////////
///////The Item has the property:  On-Hit Cast Spell: Unique Power/////////

      case X2_ITEM_EVENT_ONHITCAST:
       // * This code runs when the item has the 'OnHitCastSpell: Unique power' property
       // * and it hits a target(if it is a weapon) or is being hit (if it is a piece of armor)
       // * Note that this event fires for non PC creatures as well.

       oItem  =  GetSpellCastItem();      // The item triggering this spellscript
       oPC = OBJECT_SELF;                 // The player triggering it
       oSpellOrigin = OBJECT_SELF ;      // Where the spell came from
       oSpellTarget = GetSpellTargetObject(); // What the spell is aimed at

       //Your code goes here

       break;

///////////////////////////////////////////////////////////////////////////
/////////////Cast Spell: Unique Power /or/ Activate Item//////////////////

  //I seperated this cause it's more commonly used..
  case X2_ITEM_EVENT_ACTIVATE:
  // * This code runs when the Unique Power property of the item is used
  // * or the item is activated. Note that this event fires for PCs only.

   oPC   = GetItemActivator();        // The player who activated the item
   oItem = GetItemActivated();         // The item that was activated
   oTarget = GetItemActivatedTarget();   //The target of the item's power
   lway = GetItemActivatedTargetLocation(); //To get the location of the target!

	nWLvl = GetLevelByClass(CLASS_TYPE_WIZARD, oPC);
    
	nSLvl = GetLevelByClass(CLASS_TYPE_SORCERER, oPC)
			+GetLevelByClass(CLASS_TYPE_DREAD_NECROMANCER, oPC)
			+GetLevelByClass(CLASS_TYPE_WARMAGE, oPC)
			+GetLevelByClass(CLASS_TYPE_SHADOWCASTER, oPC)
			+GetLevelByClass(CLASS_TYPE_WARLOCK, oPC)
			+GetLevelByClass(CLASS_TYPE_DRAGONFIRE_ADEPT, oPC);	
	
    //Determine effects...
    if(nWLvl >=21)
    {
    nRDC = nWLvl + 10;
    nCDmg = d12(1) * nRDC;
    nDDmg = d6(1) * nRDC;
    }
    else if(nSLvl >=21)
    {
    nRDC = nSLvl + 10;
    nCDmg = d12(1) * nRDC;
    nDDmg = d6(1) * nRDC;
    }
    else {nRDC = 0;}

    if(nRDC ==0)
    {
      FloatingTextStringOnCreature("You must be at least a level 21 Wizard or Sorcerer to use this item!", oPC);
     return;
    }

  if(WillSave(oPC, nRDC, SAVING_THROW_TYPE_NONE)==0)
   {
    //If Spell Resistance is not high enough! (50 SR max it can beat)
    if(GetSpellResistance(oPC)<=nRDC)
      {
       eVis = EffectVisualEffect(VFX_BEAM_DISINTEGRATE, TRUE);
       ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, oTarget);
       eEffect = EffectDeath(TRUE, FALSE);
       eEffect = SupernaturalEffect(eEffect);
       DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_INSTANT, eEffect, oTarget));
      }
     else
     {
       eVis = EffectVisualEffect(VFX_BEAM_DISINTEGRATE, TRUE);
       ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, oTarget);
       eEffect = EffectDamage(nCDmg, DAMAGE_TYPE_MAGICAL, DAMAGE_POWER_ENERGY);
       eEffect = SupernaturalEffect(eEffect);
       DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_INSTANT, eEffect, oTarget));
     }
   }
   //No Matter what they will take damage!
    else
     {
       eVis = EffectVisualEffect(VFX_BEAM_DISINTEGRATE, TRUE);
       ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, oTarget, 3.0f);
       eEffect = EffectDamage(nDDmg, DAMAGE_TYPE_MAGICAL, DAMAGE_POWER_ENERGY);
       eEffect = SupernaturalEffect(eEffect);
       ApplyEffectToObject(DURATION_TYPE_INSTANT, eEffect, oTarget, 3.0f);
     }



       break;

///////////////////////////////////////////////////////////////////////////
///////////When the User Equips this item////////////////////////////////

      case X2_ITEM_EVENT_EQUIP:
      // * This code runs when the item is equipped
      // * Note that this event fires for PCs only

      oPC = GetPCItemLastEquippedBy(); // The player who equipped the item
      oItem = GetPCItemLastEquipped(); // The item that was equipped

      //Your code goes here

      break;

////////////////////////////////////////////////////////////////////////////
/////////////When the User Unequips this item//////////////////////////////

     case X2_ITEM_EVENT_UNEQUIP:
     // * This code runs when the item is unequipped
     // * Note that this event fires for PCs only

     oPC    = GetPCItemLastUnequippedBy();// The player who unequipped the item
     oItem  = GetPCItemLastUnequipped(); // The item that was unequipped

     //Your code goes here

     break;

////////////////////////////////////////////////////////////////////////////
////////////Everytime ANYONE Acquires this item////////////////////////////

     case X2_ITEM_EVENT_ACQUIRE:
     // * This code runs when the item is acquired
     // * Note that this event fires for PCs only

     oPC = GetModuleItemAcquiredBy();  // The player who acquired the item
     oItem  = GetModuleItemAcquired(); // The item that was acquired

     //Your code goes here

     break;

////////////////////////////////////////////////////////////////////////////
//////////Everytime ANYONE Loses this item/////////////////////////////////

    case X2_ITEM_EVENT_UNACQUIRE:
    // * This code runs when the item is unacquired
    // * Note that this event fires for PCs only

    oPC = GetModuleItemLostBy();  // The player who dropped the item
    oItem  = GetModuleItemLost(); // The item that was dropped

    //Your code goes here

    break;

////////////////////////////////////////////////////////////////////////////
/////Everytime ANYONE Cast a spell at this item////////////////////////////

    case X2_ITEM_EVENT_SPELLCAST_AT:
    //* This code runs when a PC or DM casts a spell from one of the
    //* standard spellbooks on the item

    oPC = OBJECT_SELF;              // The player who cast the spell
    oItem  = GetSpellTargetObject();// The item targeted by the spell
    iSpell = GetSpellId();          // The id of the spell that was cast
                                    // See the list of SPELL_* constants

    //Your code goes here

    //Change the following line from X2_EXECUTE_SCRIPT_CONTINUE to
    //X2_EXECUTE_SCRIPT_END if you want to prevent the spell that was
    //cast on the item from taking effect
    nResult = X2_EXECUTE_SCRIPT_CONTINUE;
    break;
    }

    //Pass the return value back to the calling script
    SetExecutedScriptReturnValue(nResult);
}

